cd /tmp/mame-master

# Patch new MAME source
sed -bi "s/# OVERRIDE_CC = cc/OVERRIDE_CC = clang/g; s/# OVERRIDE_CXX = c++/OVERRIDE_CXX = clang++/g" makefile
sed -bi "s/# SSE2 = 1/SSE2 = 1/g" makefile

# Clang ERRORs: '__thiscall__' only applies to function types (emu/emu.h) and SOCKET socket_ and HANDLE handle_ (emu/http.cpp)
sed -bi "s/MAME_ABI_CXX_MEMBER_CALL __thiscall/MAME_ABI_CXX_MEMBER_CALL/g" src/lib/util/abi.h
sed -bi "s/HANDLE handle_/\x2f\x2fHANDLE handle_/g" 3rdparty/asio/include/asio/detail/win_iocp_handle_service.hpp
sed -bi "s/iocp_op_cancellation(HANDLE/HANDLE handle_; iocp_op_cancellation(HANDLE/g" 3rdparty/asio/include/asio/detail/win_iocp_handle_service.hpp
sed -bi "s/SOCKET socket_/\x2f\x2fSOCKET socket_/g" 3rdparty/asio/include/asio/detail/win_iocp_socket_service_base.hpp
sed -bi "s/\([a-z]*\)_op_cancellation(SOCKET/SOCKET socket_; \1_op_cancellation(SOCKET/g" 3rdparty/asio/include/asio/detail/win_iocp_socket_service_base.hpp

# 'TaskDialog' missing in comctl32.dll (Windows XP)
sed -bi "s/\x09\x09\x09if \x28SUCCEEDED\x28SHCreateItem/\x2f\x2f\x09\x09\x09if (SUCCEEDED(SHCreateItem/g" src/osd/modules/debugger/win/consolewininfo.cpp
sed -bi "s/\t\tint pressed;/#ifdef UNUSED_FUNCTION\n\t\tint pressed;/g" src/osd/modules/debugger/win/consolewininfo.cpp
sed -bi "s/\t\t\t\t&pressed);/\t\t\t\t\&pressed);\n#endif/g" src/osd/modules/debugger/win/consolewininfo.cpp

# 'CancelIoEx' missing in kernel32.dll (Windows XP)
sed -bi "s/_WIN32_WINNT >= 0x0600/_WIN32_WINNT >= 0x2000/g" 3rdparty/asio/include/asio/detail/win_iocp_handle_service.hpp
sed -bi "s/_WIN32_WINNT >= 0x0600/_WIN32_WINNT >= 0x2000/g" 3rdparty/asio/include/asio/detail/win_iocp_socket_service_base.hpp
sed -bi "s/_WIN32_WINNT >= 0x0600/_WIN32_WINNT >= 0x2000/g" 3rdparty/asio/include/asio/detail/impl/win_iocp_socket_service_base.ipp

# 'CreateSymbolicLinkA' missing in kernel32.dll (Windows XP)
sed -bi "s/int result = symbolic \x3f CreateSymbolicLink(newpath, oldpath, is_dir)/int result = 0; if (symbolic) {lua_pushnil(L); lua_pushstring(L, \"Symbolic links are not supported on Windows XP.\"); return 2;} else {if (CreateHardLink(newpath, oldpath, NULL) != 0) {result = 1;}}/g;/      : CreateHardLink(newpath, oldpath, NULL);/d" 3rdparty/luafilesystem/src/lfs.c
sed -bi "s/GetFinalPathNameByHandle(h, target, size, FILE_NAME_OPENED)/GetFullPathName(file, size, target, NULL)/g" 3rdparty/luafilesystem/src/lfs.c

# Creating WbemLocator failed + XInput device detection failed (Windows XP)
sed -bi "s/osd_printf_error(\"Creating Wbem/\/\/osd_printf_error(\"Creating Wbem/g" src/osd/modules/input/input_winhybrid.cpp
sed -bi "s/osd_printf_warning(\"XInput/\/\/osd_printf_warning(\"XInput/g" src/osd/modules/input/input_winhybrid.cpp


cd /tmp
echo " "
echo " "
echo " "
echo "Auto-generate arcade.flt and mess.flt files..."
echo " "
cmd //c arcade+mess-flt.bat

cd mame-master
